(*
    HLins: insert http-links into HTML documents.
    See http://www.lri.fr/~treinen/hlins

    Copyright (C) 1999 Ralf Treinen <treinen@lri.fr>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*)


open Array;;


type automaton = {
  max_path_length:   int;
  number_of_states:  int;
  tree:              (char*int) list array;
  level:             int array;               
  board:             int array;
  suf:               int array;
  found:             (int list) array;
  expand:            (int list) array
};;                     


(* function to print an automaton *)
let print_automaton auto =
  let rec print_auto i =
    if i = auto.number_of_states then prerr_newline ()
    else begin
      prerr_int i;
      prerr_char '[';
      prerr_int auto.level.(i);
      prerr_char ']';
      prerr_char '<';
      prerr_int auto.suf.(i);
      prerr_char '>';
      prerr_char '(';
      prerr_int auto.board.(i);
      prerr_char ')';
      List.iter (function (c,s) -> prerr_char c; prerr_char ':'; prerr_int s;
		   prerr_string", ") auto.tree.(i);
      prerr_char '|';
      List.iter (function n -> prerr_int n; prerr_char ' ') auto.found.(i);
      prerr_char '|';
      List.iter (function n -> prerr_int n; prerr_char ' ') auto.expand.(i);
      prerr_string "\n";
      print_auto (i+1)
    end
  in
    begin
      prerr_string "state[level]<suf>(board)tree|found|expand|\n";
      print_auto 0
    end;;





