(*
    HLins: insert http-links into HTML documents.
    See http://www.lri.fr/~treinen/hlins

    Copyright (C) 1999 Ralf Treinen <treinen@lri.fr>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*)


(**************************************************************************)
(* useful operations on names                                             *)
(**************************************************************************)


(* replaces all non-empty sequence of spaces by one space *)
val normalise: string -> string;;


(* replace "==" by "=" *)
val unescape_equal: string -> string;;


(* returns -1 if the string does not contain a blank or does not contain a
   dash after the last blank, returns the index of the last dash
   otherwise.
*)
val dash_position: string -> int;;


(* returns the list starting with the name itself and followed by its
   abbrevaition of first names, where ! are unescaped. The result is
   always on-empty.
*)
 val abbreviate: string -> string list;;













